---
title: Column layouts
slug: Web/CSS/Layout_cookbook/Column_layouts
tags:
  - CSS
  - Guide
  - Layout
  - Multi-col
  - columns
  - cookbook
  - flexbox
  - grid
---
<div>{{CSSRef}}</div>

<p class="summary">You will often need to create a layout which has a number of columns, and CSS provides several ways to do this. Whether you use Grid, Flexbox or Multi-column layout will depend on what you are trying to achieve, and in this recipe we explore these options.</p>

<p><img alt="three different styles of layouts which have two columns in the container." src="https://mdn.mozillademos.org/files/16183/cookbook-multiple-columns.png" style="height: 406px; width: 1541px;"></p>

<h2 id="Requirements">Requirements</h2>

<p>There are a number of design patterns you might want to achieve with your columns:</p>

<ul>
 <li>A continuous thread of content broken up into newspaper-style columns.</li>
 <li>A single row of items arranged as columns, with all heights being equal.</li>
 <li>Multiple rows of columns lined up by row and column.</li>
</ul>

<h2 id="The_recipes">The recipes</h2>

<p>You need to choose different layout methods in order to achieve your requirements.</p>

<h3 id="A_continuous_thread_of_content_—_multi-column_layout">A continuous thread of content — multi-column layout</h3>

<p>If you create columns using multi-column layout your text will remain as a continuous stream filling each column in turn. The columns must all be the same size, and you are unable to target an individual column or the content of an individual column.</p>

<p>You can control the gaps between columns with the {{cssxref("column-gap")}} property, and add a rule between columns using {{cssxref("column-rule")}}.</p>

<p>{{EmbedGHLiveSample("css-examples/css-cookbook/columns-multicol.html", '100%', 720)}}</p>

<div class="note">
<p><a href="https://github.com/mdn/css-examples/blob/master/css-cookbook/columns-multicol--download.html">Download this example</a></p>
</div>

<p>Use multicol when:</p>

<ul>
 <li>You want your text to display in newspaper-like columns.</li>
 <li>You have a set of small items you want to break into columns.</li>
 <li>You do not need to target individual column boxes for styling.</li>
</ul>

<h3 id="A_single_row_of_items_with_equal_heights_—_flexbox">A single row of items with equal heights — flexbox</h3>

<p>Flexbox can be used to break content into columns by setting {{cssxref("flex-direction")}} to <code>row</code>, however flexbox targets the elements inside the flex container and will place each direct child into a new column. This is a different behavior to what you saw with multicol.</p>

<p>There is currently no way to add a rule between flex items, and browser support for the {{cssxref("column-gap")}} and {{cssxref("row-gap")}} properties is limited. Therefore to create gaps between items use a margin.</p>

<p>{{EmbedGHLiveSample("css-examples/css-cookbook/columns-flexbox.html", '100%', 720)}}</p>

<div class="note">
<p><a href="https://github.com/mdn/css-examples/blob/master/css-cookbook/columns-flexbox--download.html">Download this example</a></p>
</div>

<p>Flexbox can also be used to create layouts where the flex items wrap onto new rows, by setting the {{cssxref("flex-wrap")}} property on the container to <code>wrap</code>. These new flex lines will distribute space along that line only — the items in the new line will not line up with items in the line above, as you'll see in the example below. This is why flexbox is described as one-dimensional. It is designed for controlling layout as a row or a column, but not both at the same time.</p>

<p>{{EmbedGHLiveSample("css-examples/css-cookbook/columns-flexbox-wrapping.html", '100%', 720)}}</p>

<div class="note">
<p><a href="https://github.com/mdn/css-examples/blob/master/css-cookbook/columns-flexbox-wrapping--download.html">Download this example</a></p>
</div>

<p>Use flexbox:</p>

<ul>
 <li>For single rows or columns of items.</li>
 <li>When you want to do alignment on the cross axis after laying out your items.</li>
 <li>When you are happy for wrapped items to share out space along their line only and not line up with items in other lines.</li>
</ul>

<h3 id="Lining_items_up_in_rows_and_columns_—_grid_layout">Lining items up in rows and columns — grid layout</h3>

<p>If what you want is a layout where items line up in rows and columns then you should choose CSS Grid Layout. Grid Layout works on the direct children of the grid container in a similar way to the manner in which flexbox works on the direct children of the flex container, however with CSS Grid you can line your items up in rows and columns — it is described as two-dimensional.</p>

<p>{{EmbedGHLiveSample("css-examples/css-cookbook/columns-grid.html", '100%', 720)}}</p>

<div class="note">
<p><a href="https://github.com/mdn/css-examples/blob/master/css-cookbook/columns-grid--download.html">Download this example</a></p>
</div>

<p>Use Grid:</p>

<ul>
 <li>For multiple rows or columns of items.</li>
 <li>When you want to be able to align the items on the block and inline axes.</li>
 <li>When you want items to line up in rows and columns.</li>
</ul>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>The various layout methods have different browser support. See the charts below for details on basic support for the properties used.</p>

<h4 id="column-width">column-width</h4>

<p>{{Compat("css.properties.column-width")}}</p>

<h4 id="column-rule">column-rule</h4>

<p>{{Compat("css.properties.column-rule")}}</p>

<h4 id="flex">flex</h4>

<p>{{Compat("css.properties.flex")}}</p>

<h4 id="flex-wrap">flex-wrap</h4>

<p>{{Compat("css.properties.flex-wrap")}}</p>

<h4 id="grid-template-columns">grid-template-columns</h4>

<p>{{Compat("css.properties.grid-template-columns")}}</p>

<h2 id="Resources_on_MDN">Resources on MDN</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/CSS_Columns">Guide to Multi-column Layout</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout/">Guide to Flexbox</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout">Guide to CSS Grid Layout</a></li>
</ul>
